<?php
require_once('../../config.php');
global $CFG, $USER;
require_once($CFG->dirroot.'/lib/blocklib.php');

if (! $site = get_site()) {
    redirect($CFG->wwwroot .'/'. $CFG->admin .'/index.php');
}

print_header(strip_tags($site->fullname), $site->fullname, 'Contact Form', '', '<meta name="description" content="'. s(strip_tags($site->summary)) .'">',
             true, '', '');

optional_variable($name, '');
optional_variable($email, '');
optional_variable($subject, '');
optional_variable($comments, '');
optional_variable($fromcourse);

if(!is_numeric($fromcourse) || $fromcourse == 0){
    $fromcourse = SITEID;
    $messagePreface = get_string('commentreceived', 'block_contact_form') .' '. get_string('site', 'block_contact_form') .': '. $CFG->wwwroot;
} else {
    if (! $course = get_record('course', 'id', $fromcourse) ) {
        error('That\'s an invalid course id: '. $fromcourse);
    }
    $messagePreface = get_string('commentreceived', 'block_contact_form') .' '. get_string('course', 'block_contact_form') .': '. $CFG->wwwroot . '/course/view.php?&id='. $fromcourse;
}

if ($comments != '') {
    //data was submitted from this form, process it
    if (! validate_email($email)) {
        $err = get_string('invalidemail');
    } else {
        $from->email = $email;
        $from->firstname = $name;
        $from->lastname = '';
        $from->maildisplay = true;
        
        $recipient = get_admin(); //get the administrator account info as email recipient
        
        $messagePreface .= '
From:  '. $name .'
Email:  '. $email .'
Message:


            ';
        $comments = $messagePreface . $comments;
        $comments = wordwrap( $comments, 1024 );
        
        //now that the admin has been notified send notice to teachers
        //check to make sure the course is not the site page first
        if ($fromcourse != 0 && $fromcourse != 1) {
            
            //set the subject to start with [shortname]
            $subject = '[' . $course->shortname . '] '. $subject;

            if(isset($CFG->block_contact_form_admin_cc) && $CFG->block_contact_form_admin_cc == 1){
                //we're in a course and admin should get CC
                /// Check for error condition the hard way. Workaround for a bug in moodle discovered by Dan Marsden. If email is not configured properly and email_to_user() is called then "ERROR:" with no message prints out.
                ob_start();
                @email_to_user($recipient, $from, stripslashes_safe($subject), stripslashes_safe($comments));
                $error = ob_get_contents();
                ob_end_clean();
                if ($CFG->debug && preg_match("/^ERROR:/", $error) ) {
                    print 'An error was encountered trying to send email in comments.php. It is likely that your email settings are not configured properly. The error reported was "'. $error .'"<br />';
                }                
            }
            //Get teachers
            $sql = "SELECT u.id, u.firstname, u.lastname, u.email
                    FROM {$CFG->prefix}user u,
                    {$CFG->prefix}user_teachers s
                    WHERE u.id = s.userid AND
                    s.course = $fromcourse";
            $teachers = get_records_sql($sql);
            if ($teachers) {
                foreach ($teachers as $teacher) {
                    $recipient = $teacher;
                    /// Check for error condition the hard way. Workaround for a bug in moodle discovered by Dan Marsden. If email is not configured properly and email_to_user() is called then "ERROR:" with no message prints out.
                    ob_start();
                    @email_to_user($recipient, $from, stripslashes_safe($subject), stripslashes_safe($comments));
                    $error = ob_get_contents();
                    ob_end_clean();
                    if ($CFG->debug && preg_match("/^ERROR:/", $error) ) {
                        print 'An error was encountered trying to send email in comments.php. It is likely that your email settings are not configured properly. The error reported was "'. $error .'"<br />';
                    }
                }
            }
        } else {
            if (!isset($CFG->block_contact_form_subject_prefix)) {
                if ($site = get_site()) {
                    $CFG->block_contact_form_subject_prefix = '['. strip_tags($site->shortname) .']';
                } else {
                    $CFG->block_contact_form_subject_prefix = '[moodle contact]';
                }
            } 
            $subject = $CFG->block_contact_form_subject_prefix . $subject;
            //we're not referenced from a course - just email the admin
            /// Check for error condition the hard way. Workaround for a bug in moodle discovered by Dan Marsden. If email is not configured properly and email_to_user() is called then "ERROR:" with no message prints out.
            ob_start();
            @email_to_user($recipient, $from, stripslashes_safe($subject), stripslashes_safe($comments));
            $error = ob_get_contents();
            ob_end_clean();
            if ($CFG->debug && preg_match("/^ERROR:/", $error) ) {
                print 'An error was encountered trying to send email in comments.php. It is likely that your email settings are not configured properly. The error reported was "'. $error .'"<br />';
            }
             add_to_log($fromcourse, 'Contact Form Block', 'send mail', '', "To:$recipient; From:$from; Subject:$subject");
        }

        //Once the data is entered, redirect the user to give them visual confirmation
        redirect('thanks.php?fromcourse='. $fromcourse);
        }
    }

if(isset($err)){
    notify($err, 'red');
}

include('form.html'); //include the form html template file

print_footer(); 
?>